<?php

namespace domain\Communication\AutomaticEmail;

use domain\_\AbstractModule;

class AutomaticEmailModule extends AbstractModule
{
    public function getServices(): array
    {
        return [
            AutomaticEmailDefinition::class,
            AutomaticEmailBuilder::class,
            AutomaticEmailRepository::class,
            AutomaticEmailResolver::class,
            AutomaticEmailManager::class
        ];
    }

    public function getDefinition(): AutomaticEmailDefinition
    {
        return AutomaticEmailDefinition::getInstance();
    }

    public function getBuilder(): AutomaticEmailBuilder
    {
        return AutomaticEmailBuilder::getInstance();
    }

    public function getRepository(): AutomaticEmailRepository
    {
        return AutomaticEmailRepository::getInstance();
    }

    public function getResolver(): AutomaticEmailResolver
    {
        return AutomaticEmailResolver::getInstance();
    }

    public function getManager(): AutomaticEmailManager
    {
        return AutomaticEmailManager::getInstance();
    }
}